moSetGetSlotObjects = {};

function moSetGetSlotObjects:setUpdate(self, slot, slotName)	
	local oldFoundObjects = moGuiMiniPdaSlots.values[slot].foundObjects;
	moGuiMiniPdaSlots.values[slot].foundObjects = 0;
	moGuiMiniPdaSlots.values[slot].foundObjectsNamen = "";
	moGuiMiniPdaSlots.values[slot].productivity = 100;
	moGuiMiniPdaSlots.values[slot].objects = {};	
	--print("update slot.........".. tostring(slotName))
	function checkMapObject(modType, xmlModString, category, separated, objectName, displayName)		
		if moMapObjects[modType][1] == nil then return;end;
		for a=1, table.getn(moMapObjects[modType]) do
			if string.lower(moMapObjects[modType][a].name) == xmlModString then				
				local replaceDisplayName = displayName;
				if not string.find(moGeneralSettings.setSlotFabrikscript, xmlModString.. " ") then moGeneralSettings.setSlotFabrikscript = moGeneralSettings.setSlotFabrikscript.. xmlModString.. " ";end;
				--if moMapObjects[modType][a].name ~= xmlModString and moMapObjects[modType][a].factoryName ~= nil and xmlModString ~= string.lower(moMapObjects[modType][a].factoryName) then replaceDisplayName = moMapObjects[modType][a].factoryName;end;
				setObject(self, modType, moMapObjects[modType][a], category, separated, objectName, replaceDisplayName, slot, slotName, false, xmlModString, moMapObjects[modType][a].x, moMapObjects[modType][a].z);				
			end;
		end;
	end;
	if moObjectsMap[slotName.. "Found"] > 0 then
		for a=1, moObjectsMap[slotName.. "Found"] do		
			if moObjectsMap[slotName][a] ~= nil then
				local splitString = Utils.splitString(",", moObjectsMap[slotName][a]);
				local modType = splitString[1];
				local xmlModString = string.lower(splitString[2]);
				local category = Utils.getNoNil(splitString[3], "factory");
				local separated = false;
				if Utils.getNoNil(splitString[4], "false") == "true" then separated = true;end;
				local displayName = Utils.getNoNil(splitString[5], moLanguageXml:getTxt("factory", nil, "Factory".. a));				 
				if modType == "upk" and moGeneralSettings.upkReady or modType ~= "upk" then	
					local replaceDisplayName = string.gsub(displayName, " ", "_");					
					checkMapObject(modType, xmlModString, category, separated, replaceDisplayName.. "_".. modType, displayName);				
				end;
			end;
		end;
	end;
	if slotName == "other1" then
		if moMapObjects["fs"][1] == nil then return;end;
		for a=1, table.getn(moMapObjects["fs"]) do
			if moMapObjects["fs"][a].name == "factory" or not string.find(moGeneralSettings.setSlotFabrikscript, string.lower(moMapObjects["fs"][a].name).. " ") then				
				local displayName = moMapObjects["fs"][a].name;
				if moMapObjects["fs"][a].name == "factory" then displayName = tostring(moLanguageXml:getTxt("factory", nil, "Factory"));end;
				--if moMapObjects["fs"][a].factoryName ~= nil then displayName = moMapObjects["fs"][a].factoryName ;end;
				setObject(self, "fs", moMapObjects["fs"][a], "factory", true, "factory_fs", displayName, slot, slotName, false, "factory", moMapObjects["fs"][a].x, moMapObjects["fs"][a].z);				
			end;
		end;
	end;
	function checkPlaceableObject(modType, xmlModString, category, separated, objectName, displayName, realXmlModString)		
		if xmlModString ~= nil then
			setObject(self, modType, xmlModString, category, separated, objectName, displayName, slot, slotName, true, nil, nil, nil);
		elseif category == "heaps" and string.find(realXmlModString, "heaptiptrigger") then
			setObject(self, modType, xmlModString, category, separated, objectName, displayName, slot, slotName, true, realXmlModString, nil, nil);			
		end;
	end;
	if moObjectsPlaceable[slotName.. "Found"] > 0 then
		for a=1, moObjectsPlaceable[slotName.. "Found"] do		
			if moObjectsPlaceable[slotName][a] ~= nil then
				local splitString = Utils.splitString(",", moObjectsPlaceable[slotName][a]);
				local modType = splitString[1];			
				local xmlModString = string.lower(MultiOverlayV2.gameDir.. splitString[2]);
				if modType == "ls" then xmlModString = string.lower(splitString[2]);end;
				local category = Utils.getNoNil(splitString[3], "factory");
				local separated = false;
				if Utils.getNoNil(splitString[4], "false") == "true" then separated = true;end;
				local displayName = Utils.getNoNil(splitString[5], "factory".. a);				 
				if modType == "upk" and moGeneralSettings.upkReady or modType ~= "upk" then				
					local replaceDisplayName = string.gsub(displayName, " ", "_");					
					checkPlaceableObject(modType, g_currentMission.placeables[xmlModString], category, separated, replaceDisplayName.. "_".. modType, displayName, xmlModString);				
				end;
			end;
		end;
	end;	
	--if oldFoundObjects ~= moGuiMiniPdaSlots.values[slot].foundObjects then moGuiExtras:setSlotMaxProSwitch(self, slot);end;
	--if slotName == "animals" then print(tostring(MultiOverlayV2:tableToString(moGuiMiniPdaSlots.values[slot].objects)));end;
end;

function setObject(self, modType, objectTable, category, separated, objectName, displayName, slot, slotName, placeable, xmlModString, mapX, mapZ)	
	local inputFillTypes; 
	local outputFillTypes;
	local slotTableObject;	
	function setObjectTable(objectName, x, z)
		moGuiMiniPdaSlots.values[slot].foundObjects = moGuiMiniPdaSlots.values[slot].foundObjects+1;
		if string.len(moGuiMiniPdaSlots.values[slot].foundObjectsNamen) > 0 then
			moGuiMiniPdaSlots.values[slot].foundObjectsNamen = moGuiMiniPdaSlots.values[slot].foundObjectsNamen.. " ".. objectName;
		else
			moGuiMiniPdaSlots.values[slot].foundObjectsNamen = objectName;
		end;
		moGuiMiniPdaSlots.values[slot].objects[objectName] = {};
		slotTableObject = moGuiMiniPdaSlots.values[slot].objects[objectName];		
		if not placeable and mapX ~= nil and mapZ ~= nil then
			moGuiMiniPdaSlots.values[slot].objects[objectName].x = mapX;
			moGuiMiniPdaSlots.values[slot].objects[objectName].z = mapZ;
		else
			moGuiMiniPdaSlots.values[slot].objects[objectName].x = x;
			moGuiMiniPdaSlots.values[slot].objects[objectName].z = z;
		end;
		moGuiMiniPdaSlots.values[slot].objects[objectName].category = category;
		moGuiMiniPdaSlots.values[slot].objects[objectName].modType = modType;
		moGuiMiniPdaSlots.values[slot].objects[objectName].inputFillTypes = {};
		moGuiMiniPdaSlots.values[slot].objects[objectName].outputFillTypes = {};		
		moGuiMiniPdaSlots.values[slot].objects[objectName].special = false;			
		moGuiMiniPdaSlots.values[slot].objects[objectName].length = 1;
		moGuiMiniPdaSlots.values[slot].objects[objectName].lengthActive = 0;
		moGuiMiniPdaSlots.values[slot].objects[objectName].lengthNotActive = 0;
		moGuiMiniPdaSlots.values[slot].objects[objectName].productivity = 0;
		moGuiMiniPdaSlots.values[slot].objects[objectName].productivityColor = moGuiMiniPdaSlots.warningColor4;		
		moGuiMiniPdaSlots.values[slot].objects[objectName].displayName = displayName;		
	end;	
	local fillLevelFound = false;
	local separatedProductivity = false;
	local outputFillLevelIgnore = false;
	function setGetInputOutputFillTypes(specialTable, x, z)			
		if inputFillTypes == nil and outputFillTypes == nil or table.getn(inputFillTypes) == 0 and table.getn(outputFillTypes) == 0 then 
			return;		
		end;
		if moGuiMiniPdaSlots.values[slot].objects[objectName] == nil then 			
			setObjectTable(objectName, x ,z);			
		elseif separated then
			setObjectTable(objectName.. "_".. moGuiMiniPdaSlots.values[slot].foundObjects, x, z);
		else
			slotTableObject = moGuiMiniPdaSlots.values[slot].objects[objectName];
			slotTableObject.length = slotTableObject.length+1;
		end;
		if not specialTable and outputFillTypes ~= nil and table.getn(outputFillTypes) > 0 then
			for container,info in pairs(outputFillTypes) do					
				if slotTableObject.outputFillTypes[container] == nil then
					slotTableObject.outputFillTypes[container] = {};						
					slotTableObject.outputFillTypes[container].capacity = outputFillTypes[container][1].capacity;
					slotTableObject.outputFillTypes[container].fillLevel = outputFillTypes[container][1].fillLevel;
					slotTableObject.outputFillTypes[container].bestPrice = outputFillTypes[container][1].pricePerLiter;
					slotTableObject.outputFillTypes[container].fillTypeName = outputFillTypes[container][1].fillTypeName;					
					slotTableObject.outputFillTypes[container].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes;
					if outputFillTypes[container][1].setColor ~= nil then 
						slotTableObject.outputFillTypes[container].setColor = outputFillTypes[container][1].setColor;						
					end;
					
					if outputFillTypes[container][1].extraText ~= nil then slotTableObject.outputFillTypes[container].extraText = outputFillTypes[container][1].extraText;end;
					if outputFillTypes[container][1].fillTypeContainerName ~= nil then slotTableObject.outputFillTypes[container].fillTypeContainerName = outputFillTypes[container][1].fillTypeContainerName;end;
				else
					if outputFillTypes[container][1].capacity ~= -1 and outputFillTypes[container][1].capacity ~= -2 and outputFillTypes[container][1].capacity ~= -3 then
						slotTableObject.outputFillTypes[container].capacity = slotTableObject.outputFillTypes[container].capacity+outputFillTypes[container][1].capacity;
					elseif outputFillTypes[container][1].capacity ~= -2 or outputFillTypes[container][1].capacity ~= -3 then						
						slotTableObject.outputFillTypes[container].bestPrice = slotTableObject.outputFillTypes[container].bestPrice+outputFillTypes[container][1].pricePerLiter;
					end;
					slotTableObject.outputFillTypes[container].fillLevel = slotTableObject.outputFillTypes[container].fillLevel+outputFillTypes[container][1].fillLevel;
				end;
				if outputFillTypes[container][1].productivity ~= nil then						
					separatedProductivity = true;					
					if tonumber(moGuiMiniPdaSlots.values[slot].productivity) >= tonumber(outputFillTypes[container][1].productivity) then
						moGuiMiniPdaSlots.values[slot].productivity = tonumber(outputFillTypes[container][1].productivity);
						moGuiMiniPdaSlots.values[slot].productivityColor = outputFillTypes[container][1].productivityColor;							
					end;
					if separated then 
						slotTableObject.productivity = tonumber(outputFillTypes[container][1].productivity);
					else
						slotTableObject.productivity = tonumber(slotTableObject.productivity)+(tonumber(outputFillTypes[container][1].productivity))/slotTableObject.length;
					end;
					slotTableObject.productivityColor = outputFillTypes[container][1].productivityColor;
					--if tonumber(slotTableObject.productivity) >= tonumber(outputFillTypes[container][1].productivity) then
					--	slotTableObject.productivity = tonumber(outputFillTypes[container][1].productivity);
					--	slotTableObject.productivityColor = outputFillTypes[container][1].productivityColor;
					--end;
				end;
				if slotTableObject.outputFillTypes[container].fillLevel > 0 then
					slotTableObject.lengthActive = slotTableObject.lengthActive+1;
					fillLevelFound = true;
				else
					slotTableObject.lengthNotActive = slotTableObject.lengthNotActive+1;
				end;
				--if slotTableObject.outputFillTypes[container].capacity < 0 then outputFillLevelIgnore = true;end;	
			end;				
		end;
		if not specialTable and inputFillTypes ~= nil and table.getn(inputFillTypes) > 0 then
			for container,info in pairs(inputFillTypes) do					
				if slotTableObject.inputFillTypes[container] == nil then
					slotTableObject.inputFillTypes[container] = {};						
					slotTableObject.inputFillTypes[container].capacity = inputFillTypes[container][1].capacity;
					slotTableObject.inputFillTypes[container].fillLevel = inputFillTypes[container][1].fillLevel;
					slotTableObject.inputFillTypes[container].bestPrice = inputFillTypes[container][1].pricePerLiter;
					slotTableObject.inputFillTypes[container].fillTypeName = inputFillTypes[container][1].fillTypeName;
					slotTableObject.inputFillTypes[container].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes;
					if inputFillTypes[container][1].fillTypeContainerName ~= nil then slotTableObject.inputFillTypes[container].fillTypeContainerName = inputFillTypes[container][1].fillTypeContainerName;end;
				else
					slotTableObject.inputFillTypes[container].capacity = slotTableObject.inputFillTypes[container].capacity+inputFillTypes[container][1].capacity;
					slotTableObject.inputFillTypes[container].fillLevel = slotTableObject.inputFillTypes[container].fillLevel+inputFillTypes[container][1].fillLevel;
				end;				
				if slotTableObject.inputFillTypes[container].fillLevel > 0 then						
					fillLevelFound = true;
				end;					
			end;			
		end;
		if not separated and slotTableObject.length > 1 then
			setProductivityColor(self, slotTableObject, slot);
		end;		
	end;
	
	if placeable then
		local x,y,z;
		if xmlModString == nil then
			for k, v in pairs(objectTable) do				
				if modType == "ls" then inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getPlaceable(self, objectTable[k]);x,y,z = getWorldTranslation(objectTable[k].nodeId);end;
				if modType == "fs" then inputFillTypes, outputFillTypes = moSetGetInputOutputFs:getFs(self, objectTable[k]);x,y,z = getWorldTranslation(objectTable[k].nodeId);end;
				if modType == "upk" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpk(self, objectTable[k].base, category);x,y,z = getWorldTranslation(objectTable[k].base.rootNode);end;				
				if modType == "other" then inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, objectTable[k]);x,y,z = getWorldTranslation(objectTable[k].nodeId);end;
				setGetInputOutputFillTypes(false, x, z);
			end;
		elseif string.find(xmlModString, "heaptiptrigger") and modType == "other" then			
			for key, values in pairs(g_currentMission.tipTriggers) do
				if values.configFileName ~= nil and string.lower(values.configFileName) == xmlModString then
					inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, values, xmlModString);
					x,y,z = getWorldTranslation(values.rootNode);
					setGetInputOutputFillTypes(false, x, z);
				end;
			end;			
		end;
	else
		local x,y,z;
		if modType == "ls" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputLs:getAnimals(self, objectTable, xmlModString);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;			
			setGetInputOutputFillTypes(false);
		elseif modType == "fs" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputFs:getFs(self, objectTable, xmlModString);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;			
			setGetInputOutputFillTypes(false);
		elseif modType == "upk" and string.lower(objectTable.name) == xmlModString then			
			inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpk(self, objectTable, category);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;			
			setGetInputOutputFillTypes(false);
		elseif modType == "sr" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputSr:getSr(self, objectTable, xmlModString);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;
			setGetInputOutputFillTypes(false);
		elseif modType == "other" then 
			inputFillTypes, outputFillTypes = moSetGetInputOutputOther:getOther(self, objectTable);
			--if objectTable.x ~= nil and objectTable.z ~= nil then x = objectTable.x;z = objectTable.z;end;
			setGetInputOutputFillTypes(false);	
		end;		
	end;				
end;

function setProductivityColor(self, slotTableObject, slot)
	local ratio = slotTableObject.productivity;	
	slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor0; --moGuiExtras.colors['green'];
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
end;

function setProductivityColorOld(self, slotTableObject, slot, outputFillLevelIgnore)		
	local outputCapacity = 0;
	local outputFillLevel = 0;
	local inputCapacity = 0;
	local inputFillLevel = 0;
	local input = false;
	local output = false;
	local noProductivity = false;
	local ratio = 0;
	if slotTableObject.outputFillTypes ~= nil and table.getn(slotTableObject.outputFillTypes) > 0 and not outputFillLevelIgnore then
		for container=1, table.getn(slotTableObject.outputFillTypes) do
			if slotTableObject.outputFillTypes[container] ~= nil and slotTableObject.outputFillTypes[container].fillLevel ~= nil and slotTableObject.outputFillTypes[container].capacity ~= nil then
				outputCapacity = outputCapacity+slotTableObject.outputFillTypes[container].capacity;
				outputFillLevel = outputFillLevel+slotTableObject.outputFillTypes[container].fillLevel;
				output = true;
			end;
		end;
	end;
	if slotTableObject.inputFillTypes ~= nil and table.getn(slotTableObject.inputFillTypes) > 0 then
		for container=1, table.getn(slotTableObject.inputFillTypes) do
			if slotTableObject.inputFillTypes[container] ~= nil and slotTableObject.inputFillTypes[container].fillLevel ~= nil and slotTableObject.inputFillTypes[container].capacity ~= nil then
				inputCapacity = inputCapacity+slotTableObject.inputFillTypes[container].capacity;
				inputFillLevel = inputFillLevel+slotTableObject.inputFillTypes[container].fillLevel;
				input = true;
			end;
		end;
	end;	
	if output then
		ratio = string.format("%0.0f", Utils.getNoNil(outputFillLevel/outputCapacity*100, 0));
		if tonumber(outputFillLevel) >= tonumber(outputCapacity) then			
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['redDisabled'];
			slotTableObject.productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
			noProductivity = true;
		else
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor0; --moGuiExtras.colors['redDisabled'];
			slotTableObject.productivity = string.format("%0.0f", Utils.getNoNil(100, 0));
		end;
	end;	
	if input and not noProductivity then
		ratio = string.format("%0.0f", Utils.getNoNil(inputFillLevel/inputCapacity*100, 0));
		slotTableObject.productivity = ratio;	
		slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor0; --moGuiExtras.colors['green'];
		if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor1; --moGuiExtras.colors['greenDisabled'];
		elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor2; --moGuiExtras.colors['yellow'];
		elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor3; --moGuiExtras.colors['red'];
		elseif tonumber(ratio) < 25 then
			slotTableObject.productivityColor = moGuiMiniPdaSlots.warningColor4; --moGuiExtras.colors['redDisabled'];
		end;
	end;
	if tonumber(moGuiMiniPdaSlots.values[slot].productivity) >= tonumber(ratio) then
		moGuiMiniPdaSlots.values[slot].productivity = tonumber(ratio);	
	end;	
end;